package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.shop.service.GoodsIncomeConfigService;
import com.gxwebsoft.shop.entity.GoodsIncomeConfig;
import com.gxwebsoft.shop.param.GoodsIncomeConfigParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 分润配置控制器
 *
 * @author 科技小王子
 * @since 2024-10-06 17:55:50
 */
@Api(tags = "分润配置管理")
@RestController
@RequestMapping("/api/shop/goods-income-config")
public class GoodsIncomeConfigController extends BaseController {
    @Resource
    private GoodsIncomeConfigService goodsIncomeConfigService;

    @ApiOperation("分页查询分润配置")
    @GetMapping("/page")
    public ApiResult<PageResult<GoodsIncomeConfig>> page(GoodsIncomeConfigParam param) {
        // 使用关联查询
        return success(goodsIncomeConfigService.pageRel(param));
    }

    @ApiOperation("查询全部分润配置")
    @GetMapping()
    public ApiResult<List<GoodsIncomeConfig>> list(GoodsIncomeConfigParam param) {
        // 使用关联查询
        return success(goodsIncomeConfigService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:goodsIncomeConfig:list')")
    @ApiOperation("根据id查询分润配置")
    @GetMapping("/{id}")
    public ApiResult<GoodsIncomeConfig> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(goodsIncomeConfigService.getByIdRel(id));
    }

    @ApiOperation("添加分润配置")
    @PostMapping()
    public ApiResult<?> save(@RequestBody GoodsIncomeConfig goodsIncomeConfig) {
        GoodsIncomeConfig check = goodsIncomeConfigService.check(goodsIncomeConfig.getGoodsId(), goodsIncomeConfig.getSkuId(), goodsIncomeConfig.getMerchantShopType());
        if (check != null) return fail("该配置已存在");
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
            goodsIncomeConfig.setUserId(loginUser.getUserId());
        }
        if (goodsIncomeConfigService.save(goodsIncomeConfig)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改分润配置")
    @PutMapping()
    public ApiResult<?> update(@RequestBody GoodsIncomeConfig goodsIncomeConfig) {
        GoodsIncomeConfig check = goodsIncomeConfigService.check(goodsIncomeConfig.getGoodsId(), goodsIncomeConfig.getSkuId(), goodsIncomeConfig.getMerchantShopType());
        if (check != null && !check.getId().equals(goodsIncomeConfig.getId())) return fail("该配置已存在");
        if (goodsIncomeConfigService.updateById(goodsIncomeConfig)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除分润配置")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (goodsIncomeConfigService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加分润配置")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<GoodsIncomeConfig> list) {
        if (goodsIncomeConfigService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改分润配置")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<GoodsIncomeConfig> batchParam) {
        if (batchParam.update(goodsIncomeConfigService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除分润配置")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (goodsIncomeConfigService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
